#include <avr/io.h>
#include "config.h"




.func wait1000ms
.global wait5s
.global wait4s
.global wait3s
.global wait2s
.global wait1s
.global wait1000ms
.global wait500ms
.global wait400ms
.global wait300ms
.global wait200ms
.global wait100ms
.global wait50ms
.global wait40ms
.global wait30ms
.global wait20ms
.global wait10ms
.global wait5ms
.global wait4ms
.global wait3ms
.global wait2ms
.global wait1ms
.global wait500us
.global wait400us
.global wait300us
.global wait200us
.global wait100us
.global wait50us
.global wait40us
.global wait30us
.global wait20us
.global wait10us

;WarteSchleifen fuer ATmega8 bei 1MHz / 2MHz / 4MHz und 8MHz
; Speicherbelegung für Programmspeicher: (inclusive 2 Byte Watch Dog reset bei wait100ms)
; 68 Byte bei 1MHz
; 70 Byte bei 2MHz
; 76 Byte bei 4MHz
; 74 Byte bei 8Mhz
; Es werden keine Register benutzt.
; Routinen brauchen maximal 28 Byte Stack (RAM) für return-Adressen
; Jeder Aufruf braucht nur einen Befehl (rcall).


wait5s:
 rcall wait1s		;	12+x Return-Adressen
wait4s:
 rcall wait1s		;	12+x Return-Adressen
; run to wait3s

wait3s:
 rcall wait1s		;1s	12+x Return-Adressen
; run to wait2s		;3s

wait2s:
 rcall wait1s		;1s     12+x Return-Adressen
; run to wait1s		,2s

wait1s:
wait1000ms:	
 rcall wait500ms	;500ms	11+x Return-Adressen
;laueft in wait500ms	;1s	

wait500ms:
 rcall wait100ms	;100ms	10+x Return-Adressen
wait400ms:
 rcall wait100ms	;200ms	10+x Return-Adressen

wait300ms:
 rcall wait100ms        ;300ms	10+x Return-Adressen
; laeuft in wait200ms	;500ms	10+x Return-Adressen


wait200ms:
 rcall wait100ms	;100ms	10+x Return-Adressen
; laeuft in wait100ms 	;200ms


wait100ms:
 wdr				; alle 100ms ein Watchdog reset!
 rcall wait50ms	    	; 50ms	9+x Return-Adressen
;laeuft in wait50us 	;100ms

wait50ms:
 rcall wait10ms	    	;10ms	8+x Return-Adressen 
wait40ms:
 rcall wait10ms	    	;20ms	8+x Return-Adressen  
;laeuft in wait30us 	;50ms

wait30ms:
 rcall wait10ms	    	;10ms	8+x Return-Adressen 
;laeuft in wait20us 	;30ms

wait20ms:
 rcall wait10ms	    	;10ms	8+x Return-Adressen
; laeuft in wait10ms	;20ms

wait10ms:
 rcall wait5ms	   	;5ms	7+x Return-Adressen
; laueft in wait5ms	;10ms

wait5ms:
 rcall wait1ms	   	;1ms	6+x Return-Adressen
wait4ms:
 rcall wait1ms	   	;2ms	6+x Return-Adressen
; laueft in wait3ms	;5ms	

wait3ms:
 rcall wait1ms	   	;1ms	6+x Return-Adressen
; laeuft in wait2ms	;3ms


wait2ms:
 rcall wait1ms	   	;1ms	6+x Return-Adressen
; laeuft in wait1ms	;2ms

wait1ms:
 rcall wait500us    	;500us	5+x Return-Adressen
;laeuft in wait500us	;1ms

wait500us:
 rcall wait100us    	;100us	4+x Return-Adressen
wait400us:
 rcall wait100us    	;200us	4+x Return-Adressen
;laeuft in wait300us	;500us

wait300us:
 rcall wait100us    	;100us	4+x Return-Adressen
;laeuft in wait200us	;300us

wait200us:
 rcall wait100us    	;100us	4+x Return-Adressen
; laeuft in wait100us	;200us	


wait100us:
 rcall wait50us	    	; 50us	3+x Return-Adressen
; laeuft in wait50us	;100us	

wait50us:
 rcall wait10us     	;10us	2+x Return-Adressen
wait40us:
 rcall wait10us     	;20us
; laeuft in wait30us	;50us

wait30us:
 rcall wait10us     	;10us	2+x Return-Adressen
; laeuft in wait20us	;20us

wait20us:
 rcall wait10us		;10us	2+x Return-Adressen
; laeuft weiter in wait10us	1+x Return-Adressen


wait10us:		;	1+x Return-Adressen

#if F_CPU == 1000000
; 1MHz Version			x = 0
; rcall bei ATmega8L 4 Zyklen
 nop   ;bei ATmega8 (ohne L) braucht rcall nur 3 Zyklen
 nop
 nop
; ret braucht 4 Zyklen (je 1 µs)
#endif

#if F_CPU == 2000000
; 2MHz Version			x = 1
 rcall wait5us		;5us
; laueft weiter in wait5us

.global wait5us
wait5us:
 nop
 nop
 nop
#endif

#if F_CPU == 4000000
; 4MHz Version			x = 2
.global wait5us
.global wait2us
 rcall wait5us		;5us
wait5us:
 nop
 nop
 nop
 nop		;1us
rcall wait2us	;3us
; laueft weiter in wait2us

wait2us:
 nop
#endif

#if F_CPU == 8000000
; 8MHz Version			x = 2
.global wait5us
.global wait4us
.global wait3us
.global wait2us
.global wait1us
 rcall wait5us		;5us
; run directly to wait5us ;10us

wait5us:
 rcall wait1us		;1us
wait4us:
 rcall wait1us		;2us

wait3us:
 rcall wait1us		;3us
wait2us:
 rcall wait1us
; run directly to wait1us

wait1us:
 nop
#endif

 ret
